/*
 * FindBugs - Find bugs in Java programs
 *
 * (C) Copyright 2005 Diomidis Spinellis <dds@aueb.gr>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: MatcherV.java,v 1.1.1.1 2005/07/29 09:20:43 dds Exp $
 */

package edu.umd.cs.findbugs.apiv.java.util.regex;
import edu.umd.cs.findbugs.apiv.VerifyResult;
import java.util.regex.*;

/**
 * Generic API invocation verifier for java.util.regex.Matcher
 * Return ARGUMENT_ERROR if an argument is incorrectly null.
 *
 * @see edu.umd.cs.findbugs.detect.ApiVerify
 * @author  Diomidis Spinellis
 * @version $Revision: 1.1.1.1 $
 */
public class MatcherV {
    public VerifyResult.Value usePattern(boolean isConstant[], Matcher t, Object newPattern) {
	if (isConstant[1])
	    if (newPattern == null)
		return VerifyResult.Value.ARGUMENT_ERROR;
	    else
		return VerifyResult.Value.CORRECT;
	else
	    return VerifyResult.Value.UNVERIFIED;
    }

    public VerifyResult.Value replaceFirst(boolean isConstant[], Matcher t, Object replacement) {
	if (isConstant[1])
	    if (replacement == null)
		return VerifyResult.Value.ARGUMENT_ERROR;
	    else
		return VerifyResult.Value.CORRECT;
	else
	    return VerifyResult.Value.UNVERIFIED;
    }
}
