/*
 * FindBugs - Find bugs in Java programs
 *
 * (C) Copyright 2005 Panagiotis Louridas <louridas@aueb.gr>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: DocumentV.java,v 1.1 2005/08/05 16:15:17 panos Exp $
 */

package edu.umd.cs.findbugs.apiv.org.dom4j;
import edu.umd.cs.findbugs.apiv.VerifyResult;

/**
 * Generic API invocation verifier for org.dom4j.Document
 * Return SYNTAX_ERROR for invalid xpath expressions, and
 * ARGUMENT_ERROR in a number of other cases.
 *
 * @see edu.umd.cs.findbugs.detect.ApiVerify
 * @author Panagiotis Louridas 
 * @version $Revision: 1.1 $
 */

import org.dom4j.Document;

import java.io.StringReader;

public class DocumentV extends NodeV {

        public VerifyResult.Value matches(boolean isConstant[], Document doc,
            String expr) {
            return new NodeV().matches(isConstant, doc, expr);
        }
    
    public VerifyResult.Value numberValueOf(boolean isConstant[],
        Document doc, String expr) {
        return new NodeV().matches(isConstant, doc, expr);
    }

    public VerifyResult.Value selectNodes(boolean isConstant[],
        Document doc, String expr) {
        return new NodeV().matches(isConstant, doc, expr);
    }
                       
    public VerifyResult.Value selectNodes(boolean isConstant[],
        Document doc, String expr, String comparisonExpression) {
        return new NodeV().selectNodes(isConstant, doc, expr,
            comparisonExpression);
    }

    public VerifyResult.Value selectNodes(boolean isConstant[],
        Document doc, String expr, String comparisonExpression,
        boolean removeDublicates) {
        return new NodeV().selectNodes(isConstant, doc, expr,
            comparisonExpression, removeDublicates);
    }

    public VerifyResult.Value selectObject(boolean isConstant[], 
        Document doc, String expr) {
        return new NodeV().matches(isConstant, doc, expr);
    }

    public VerifyResult.Value selectSingleNode(boolean isConstant[],
        Document doc, String expr) {
        return new NodeV().matches(isConstant, doc, expr);
    }
    
    public VerifyResult.Value valueOf(boolean isConstant[], Document doc,
        String expr) {
        return new NodeV().matches(isConstant, doc, expr);
    }
}
